'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events

Public Class Form1
    Dim WithEvents device As Phidget22.VoltageOutput
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox
    Dim unitString As String = " V"

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        rangeCombo.DataSource = [Enum].GetValues(GetType(VoltageOutputRange))
        rangeCombo.SelectedIndex = -1
        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.VoltageOutput()

        open.openCmdLine(device)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Private Sub device_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach
        Dim attachedDevice As VoltageOutput = CType(sender, VoltageOutput)
        PhidgetInfoBox1.FillPhidgetInfo(attachedDevice)


        minOut.Text = attachedDevice.MinVoltage.ToString() + unitString
        maxOut.Text = attachedDevice.MaxVoltage.ToString() + unitString

        Try
            'different parameters are applicable for different device types
            Select Case attachedDevice.DeviceID
                Case DeviceID.PN_1002
                    rangeCombo.Text = "V Range"
                    rangeCombo.Enabled = False
                    enBtn.Enabled = True
                    attachedDevice.Enabled = 0
                    vouttrk.Maximum = 100
                    vouttrk.Minimum = -100
                Case DeviceID.PN_OUT1000
                    rangeCombo.Text = "V Range"
                    rangeCombo.Enabled = False
                    enBtn.Enabled = True
                    attachedDevice.Enabled = 0
                Case DeviceID.PN_OUT1001
                    rangeCombo.Enabled = True
                    rangeCombo.SelectedIndex = 0
                    attachedDevice.VoltageOutputRange = CType([Enum].Parse(GetType(VoltageOutputRange), rangeCombo.SelectedValue.ToString()), VoltageOutputRange) 'set up a default output range
                    enBtn.Enabled = False
                    minOut.Text = "0V"
                    maxOut.Text = "5V"
                Case DeviceID.PN_OUT1002
                    rangeCombo.Enabled = True
                    rangeCombo.SelectedIndex = 0
                    attachedDevice.VoltageOutputRange = CType([Enum].Parse(GetType(VoltageOutputRange), rangeCombo.SelectedValue.ToString()), VoltageOutputRange) 'set up a default output range
                    enBtn.Enabled = False
                    minOut.Text = "0V"
                    maxOut.Text = "5V"
                Case Else
                    'do nothing
            End Select
        Catch ex As Exception
            errorBox.addMessage("Error initializing: " + ex.Message)
        End Try

        vouttxt.Text = "0 V" 'set a default output
        vouttrk.Value = 0

        settingsBox.Visible = True
        outputBox.Visible = True
    End Sub

    Private Sub device_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()

        settingsBox.Visible = False
        outputBox.Visible = False
        enBtn.Text = "Enable"
    End Sub

    Private Sub device_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub enBtn_Click(sender As Object, e As EventArgs) Handles enBtn.Click
        'toggle enable
        Try
            If (device.Enabled = 0) Then
                device.Enabled = 1
                enBtn.Text = "Disable"
            ElseIf (device.Enabled = 1)
                device.Enabled = 0
                enBtn.Text = "Enable"
            End If
        Catch ex As Exception
            errorBox.addMessage("Error enabling: " + ex.Message)
        End Try
    End Sub

    Private Sub vouttrk_Scroll(sender As Object, e As EventArgs) Handles vouttrk.Scroll
        Try
            device.Voltage = CType(vouttrk.Value, Double) / 100.0 * device.MaxVoltage 'set the output based on track bar value
            vouttxt.Text = device.Voltage.ToString() + unitString
        Catch ex As Exception
            errorBox.addMessage("Error setting voltage: " + ex.Message)
        End Try
    End Sub

    Private Sub rangeCombo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles rangeCombo.SelectedIndexChanged
        'swap between output modes
        If (CType(sender, ComboBox).SelectedIndex = -1 Or device Is Nothing) Then
            Return
        End If

        Try
            device.VoltageOutputRange = CType([Enum].Parse(GetType(VoltageOutputRange), rangeCombo.SelectedValue.ToString()), VoltageOutputRange)
        Catch ex As Exception
            errorBox.addMessage("Error setting output range: " + ex.Message)
        End Try
    End Sub
End Class



